Freeciv-3.1: extra_type Struct Reference

Freeciv-3.1

Loading...
Searching...
No Matches
Data Fields
extra_type Struct Reference

`#include <extras.h>`

## Data Fields

int | id
struct name_translation | name
bool | ruledit_disabled
void * | ruledit_dlg
enum extra_category | category
uint16_t | causes
uint8_t | rmcauses
char | graphic_str [MAX_LEN_NAME]
char | graphic_alt [MAX_LEN_NAME]
char | activity_gfx [MAX_LEN_NAME]
char | act_gfx_alt [MAX_LEN_NAME]
char | act_gfx_alt2 [MAX_LEN_NAME]
char | rmact_gfx [MAX_LEN_NAME]
char | rmact_gfx_alt [MAX_LEN_NAME]
struct requirement_vector | reqs
struct requirement_vector | rmreqs
struct requirement_vector | appearance_reqs
struct requirement_vector | disappearance_reqs
bool | buildable
bool | generated
int | build_time
int | build_time_factor
int | removal_time
int | removal_time_factor
int | infracost
int | defense_bonus
int | appearance_chance
int | disappearance_chance
enum extra_unit_seen_type | eus
bv_unit_classes | native_to
bv_extra_flags | flags
bv_extras | conflicts
bv_extras | hidden_by
bv_extras | bridged_over
Tech_type_id | visibility_req
struct extra_type_list * | hiders
struct extra_type_list * | bridged
struct strvec * | helptext
struct { |
int special_idx |
struct base_type * base |
struct road_type * road |
struct resource_type * resource |
} | data |

## Detailed Description

Definition at line 84 of file extras.h.

## Field Documentation

## ◆ act_gfx_alt

char extra_type::act_gfx_alt[MAX_LEN_NAME]

Definition at line 97 of file extras.h.

Referenced by edit_extra::act_gfx_alt_given(), handle_ruleset_extra(), edit_extra::refresh(), and tileset_setup_extra().

## ◆ act_gfx_alt2

char extra_type::act_gfx_alt2[MAX_LEN_NAME]

Definition at line 98 of file extras.h.

Referenced by edit_extra::act_gfx_alt2_given(), handle_ruleset_extra(), edit_extra::refresh(), and tileset_setup_extra().

## ◆ activity_gfx

char extra_type::activity_gfx[MAX_LEN_NAME]

Definition at line 96 of file extras.h.

Referenced by edit_extra::act_gfx_given(), handle_ruleset_extra(), edit_extra::refresh(), and tileset_setup_extra().

## ◆ appearance_chance

int extra_type::appearance_chance

Definition at line 121 of file extras.h.

Referenced by handle_ruleset_extra().

## ◆ appearance_reqs

struct requirement_vector extra_type::appearance_reqs

Definition at line 104 of file extras.h.

Referenced by can_extra_appear(), and handle_ruleset_extra().

## ◆ base

struct base_type* extra_type::base

Definition at line 148 of file extras.h.

Referenced by base_type_init(), create_extra(), extras_free(), extras_init(), and helptext_extra().

## ◆ bridged

struct extra_type_list* extra_type::bridged

Definition at line 141 of file extras.h.

Referenced by can_build_extra_base(), and extras_init().

## ◆ bridged_over

bv_extras extra_type::bridged_over

Definition at line 131 of file extras.h.

Referenced by handle_ruleset_extra().

## ◆ build_time

int extra_type::build_time

Definition at line 114 of file extras.h.

Referenced by handle_player_place_infra(), handle_ruleset_extra(), help_update_extra(), helptext_extra(), and terrain_extra_build_time().

## ◆ build_time_factor

int extra_type::build_time_factor

Definition at line 115 of file extras.h.

Referenced by handle_player_place_infra(), handle_ruleset_extra(), and terrain_extra_build_time().

## ◆ buildable

bool extra_type::buildable

Definition at line 112 of file extras.h.

Referenced by action_creates_extra(), extra_can_be_built(), handle_ruleset_extra(), help_update_extra(), and helptext_extra().

## ◆ category

enum extra_category extra_type::category

Definition at line 90 of file extras.h.

Referenced by handle_ruleset_extra().

## ◆ causes

uint16_t extra_type::causes

Definition at line 91 of file extras.h.

Referenced by extras_init(), handle_ruleset_extra(), and is_extra_caused_by_worker_action().

## ◆ conflicts

bv_extras extra_type::conflicts

Definition at line 129 of file extras.h.

Referenced by can_extras_coexist(), get_activity_time(), handle_ruleset_extra(), load_ruleset_terrain(), and tile_has_conflicting_extra().

## ◆ [struct]

struct { ... } extra_type::data

Referenced by base_callback(), base_callback(), base_type_init(), bg_append_callback(), bg_assign_callback(), bg_select_callback(), clean_menu_callback(), create_extra(), extras_free(), extras_init(), government_callback(), government_callback(), handle_ruleset_extra(), helptext_extra(), irrigation_callback(), mine_callback(), resource_type_init(), road_callback(), road_callback(), and road_type_init().

## ◆ defense_bonus

int extra_type::defense_bonus

Definition at line 120 of file extras.h.

Referenced by handle_ruleset_extra(), and helptext_extra().

## ◆ disappearance_chance

int extra_type::disappearance_chance

Definition at line 122 of file extras.h.

Referenced by handle_ruleset_extra().

## ◆ disappearance_reqs

struct requirement_vector extra_type::disappearance_reqs

Definition at line 105 of file extras.h.

Referenced by can_extra_disappear(), and handle_ruleset_extra().

## ◆ eus

enum extra_unit_seen_type extra_type::eus

Definition at line 124 of file extras.h.

Referenced by create_extra(), destroy_extra(), handle_ruleset_extra(), helptext_extra(), and map_claim_base().

## ◆ flags

bv_extra_flags extra_type::flags

Definition at line 128 of file extras.h.

Referenced by edit_extra::closeEvent(), edit_extra::edit_extra(), extra_has_flag(), handle_ruleset_extra(), and tab_extras::initialize_new_extra().

## ◆ generated

bool extra_type::generated

Definition at line 113 of file extras.h.

Referenced by handle_ruleset_extra(), helptext_extra(), and rand_extra_for_tile().

## ◆ graphic_alt

char extra_type::graphic_alt[MAX_LEN_NAME]

Definition at line 95 of file extras.h.

Referenced by edit_extra::gfx_tag_alt_given(), handle_ruleset_extra(), edit_extra::refresh(), and tileset_setup_extra().

## ◆ graphic_str

char extra_type::graphic_str[MAX_LEN_NAME]

Definition at line 94 of file extras.h.

Referenced by edit_extra::gfx_tag_given(), handle_ruleset_extra(), edit_extra::refresh(), tileset_setup_extra(), and tileset_setup_road().

## ◆ helptext

struct strvec* extra_type::helptext

Definition at line 143 of file extras.h.

Referenced by extras_free(), extras_init(), handle_ruleset_extra(), and helptext_extra().

## ◆ hidden_by

bv_extras extra_type::hidden_by

Definition at line 130 of file extras.h.

Referenced by handle_ruleset_extra(), and tile_has_visible_extra().

## ◆ hiders

struct extra_type_list* extra_type::hiders

Definition at line 138 of file extras.h.

Referenced by extras_init(), and fill_road_sprite_array().

## ◆ id

int extra_type::id

Definition at line 86 of file extras.h.

Referenced by api_edit_perform_action_unit_vs_tile_extra(), extra_number(), extras_init(), infra_selected_callback(), select_tgt_extra(), and tile_resource_is_valid().

## ◆ infracost

int extra_type::infracost

Definition at line 118 of file extras.h.

Referenced by handle_player_place_infra(), handle_ruleset_extra(), helptext_extra(), and player_can_place_extra().

## ◆ name

struct name_translation extra_type::name

Definition at line 87 of file extras.h.

Referenced by extra_name_translation(), extra_rule_name(), handle_ruleset_extra(), tab_extras::initialize_new_extra(), load_terrain_names(), tab_extras::name_given(), and tab_extras::update_extra_info().

## ◆ native_to

bv_unit_classes extra_type::native_to

Definition at line 126 of file extras.h.

Referenced by edit_extra::closeEvent(), edit_extra::edit_extra(), handle_ruleset_extra(), and is_native_extra_to_uclass().

## ◆ removal_time

int extra_type::removal_time

Definition at line 116 of file extras.h.

Referenced by handle_ruleset_extra(), helptext_extra(), and terrain_extra_removal_time().

## ◆ removal_time_factor

int extra_type::removal_time_factor

Definition at line 117 of file extras.h.

Referenced by handle_ruleset_extra(), helptext_extra(), and terrain_extra_removal_time().

## ◆ reqs

struct requirement_vector extra_type::reqs

Definition at line 102 of file extras.h.

Referenced by add_recursive_extras(), adv_settlers_road_bonus(), are_road_reqs_fulfilled(), can_build_base(), can_build_extra(), can_unit_do_connect(), check_recursive_road_connect(), tab_extras::edit_reqs(), handle_ruleset_extra(), helptext_extra(), is_native_tile_to_extra(), is_native_tile_to_road(), move_type_from_extra(), order_recursive_roads(), player_can_build_base(), and player_can_build_extra().

## ◆ resource

struct resource_type* extra_type::resource

Definition at line 150 of file extras.h.

Referenced by extras_free(), extras_init(), resource_type_init(), send_tile_info(), and terrain_canvas().

## ◆ rmact_gfx

char extra_type::rmact_gfx[MAX_LEN_NAME]

Definition at line 99 of file extras.h.

Referenced by handle_ruleset_extra(), edit_extra::refresh(), edit_extra::rmact_gfx_given(), and tileset_setup_extra().

## ◆ rmact_gfx_alt

char extra_type::rmact_gfx_alt[MAX_LEN_NAME]

Definition at line 100 of file extras.h.

Referenced by handle_ruleset_extra(), edit_extra::refresh(), edit_extra::rmact_gfx_alt_given(), and tileset_setup_extra().

## ◆ rmcauses

uint8_t extra_type::rmcauses

Definition at line 92 of file extras.h.

Referenced by extras_init(), handle_ruleset_extra(), is_extra_removed_by(), is_extra_removed_by_worker_action(), and rscompat_extra_adjust_3_1().

## ◆ rmreqs

struct requirement_vector extra_type::rmreqs

Definition at line 103 of file extras.h.

Referenced by can_remove_extra(), handle_ruleset_extra(), helptext_extra(), and player_can_remove_extra().

## ◆ road

struct road_type* extra_type::road

Definition at line 149 of file extras.h.

Referenced by extras_free(), extras_init(), helptext_extra(), road_type_init(), and tileset_setup_road().

## ◆ ruledit_disabled

bool extra_type::ruledit_disabled

Definition at line 88 of file extras.h.

Referenced by tab_extras::add_now(), tab_extras::delete_now(), extras_init(), tab_extras::name_given(), and unit_order_list_is_sane().

## ◆ ruledit_dlg

void* extra_type::ruledit_dlg

Definition at line 89 of file extras.h.

Referenced by edit_extra::closeEvent(), tab_extras::delete_now(), tab_extras::edit_now(), and extras_init().

## ◆ special_idx

int extra_type::special_idx

Definition at line 147 of file extras.h.

Referenced by extras_init(), and handle_ruleset_extra().

## ◆ visibility_req

Tech_type_id extra_type::visibility_req

Definition at line 133 of file extras.h.

Referenced by extras_init(), handle_ruleset_extra(), helptext_extra(), and player_knows_extra_exist().